package com.ejie.ad74a.control;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.dao.UnidadesBaseDao;
import com.ejie.ad74a.exceptions.Ad74aWebserviceException;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.Avisos;
import com.ejie.ad74a.model.Ayuntamientos;
import com.ejie.ad74a.model.ConvivientesInfSoci;
import com.ejie.ad74a.model.Expedientes;
import com.ejie.ad74a.model.InformeSocial;
import com.ejie.ad74a.model.InformeSocialPDF;
import com.ejie.ad74a.model.Informes;
import com.ejie.ad74a.model.MaestroActores;
import com.ejie.ad74a.model.MaestroSubtiposAviso;
import com.ejie.ad74a.model.MaestroTiposAviso;
import com.ejie.ad74a.model.MaestroTrSociales;
import com.ejie.ad74a.model.Solicitantes;
import com.ejie.ad74a.model.UnidadesBase;
import com.ejie.ad74a.model.Usuarios;
import com.ejie.ad74a.service.AvisosService;
import com.ejie.ad74a.service.AyuntamientosService;
import com.ejie.ad74a.service.ConvivientesInfSociService;
import com.ejie.ad74a.service.ExpedientesService;
import com.ejie.ad74a.service.InformeSocialService;
import com.ejie.ad74a.service.InformesService;
import com.ejie.ad74a.service.MaestroTrSocialesService;
import com.ejie.ad74a.service.SolicitantesService;
import com.ejie.ad74a.service.UnidadesBaseService;
import com.ejie.ad74a.service.UsuariosService;
import com.ejie.ad74a.service.documentos.DocumentosService;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.UtilWeb;
import com.ejie.ad74a.util.comun.Utilidades;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.ActoresEnum;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.util.constantes.EstadoInformesEnum;
import com.ejie.ad74a.util.constantes.ProcedimientosEnum;
import com.ejie.ad74a.util.constantes.SubTipoAvisoEnum;
import com.ejie.ad74a.util.constantes.TipoAvisoEnum;
import com.ejie.ad74a.util.constantes.TipoInformesEnum;
import com.ejie.ad74a.util.constantes.TipoSolicitanteEnum;
import com.ejie.ad74a.util.pid.Ad74aPIDws;
import com.ejie.ad74a.util.pif.Ad74aPIFws;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;

import v90.padoc.stub.W43DfDocument;

/**
 * InformesController generated by UDA, 19-abr-2023 16:38:36.
 * 
 * @author UDA
 */

@Controller
@RequestMapping(value = "/informes")

public class InformesController {

	private static final Logger logger = LoggerFactory.getLogger(InformesController.class);

	@Autowired
	private InformesService informesService;

	@Autowired
	private AvisosService avisosService;

	@Autowired
	private UnidadesBaseDao unidadesBaseDao;

	@Autowired
	private SolicitantesService solicitantesService;

	@Autowired
	private ExpedientesService expedientesService;

	@Autowired
	private MaestroTrSocialesService maestroTrSocialesService;

	@Autowired
	private DocumentosService documentosService;

	@Autowired
	private InformeSocialService informeSocialService;

	@javax.annotation.Resource
	private ReloadableResourceBundleMessageSource appMessageSource;

	@Autowired
	private Properties appConfiguration;

	@Autowired
	private AyuntamientosService ayuntamientosService;

	@Autowired
	private UsuariosService usuariosService;

	@Autowired
	private ConvivientesInfSociService convivientesInfSociService;

	@Autowired
	private UnidadesBaseService unidadesBaseService;

	@Autowired
	private Ad74aPIDws pidWS;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idInforme16 Long
	 * @return Informes Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idInforme16}", method = RequestMethod.GET)
	public @ResponseBody Informes get(@PathVariable Long idInforme16) {
		Informes informes = new Informes();
		informes.setIdInforme16(idInforme16);
		informes = this.informesService.find(informes);
		InformesController.logger.info("[GET - findBy_PK] : Obtener Informes por PK");
		return informes;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterInformes Informes Objeto que contiene los parametros de filtrado
	 *                       utilizados en la busqueda.
	 * @return List<Informes> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Informes> getAll(@ModelAttribute Informes filterInformes) {
		InformesController.logger.info("[GET - find_ALL] : Obtener Informes por filtro");
		return this.informesService.findAll(filterInformes, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param informes Informes Bean que contiene la informacion a modificar.
	 * @return Informes Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody Informes edit(@RequestBody Informes informes) {
		Informes informesAux = this.informesService.update(informes);
		InformesController.logger.info("[PUT] : Informes actualizado correctamente");
		return informesAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param informes Informes Bean que contiene la informacion con la que se va a
	 *                 crear el nuevo registro.
	 * @return Informes Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody Informes add(@RequestBody Informes informes) {
		Informes informesAux = this.informesService.add(informes);
		InformesController.logger.info("[POST] : Informes insertado correctamente");
		return informesAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al identificador
	 * especificado.
	 *
	 * @param idInforme16 Long Identificador del objeto que se desea eliminar.
	 * @return Informes Bean eliminado.
	 */
	@RequestMapping(value = "/{idInforme16}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Informes remove(@PathVariable Long idInforme16) {
		Informes informes = new Informes();
		informes.setIdInforme16(idInforme16);
		this.informesService.remove(informes);
		InformesController.logger.info("[DELETE] : Informes borrado correctamente");
		return informes;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model, HttpServletRequest request) {
		InformesController.logger.info("[GET - View] : informes");
		model.addAttribute("informes", new Informes());
		model.addAttribute("TipoSolicitante", TipoSolicitanteEnum.values());

		// No se podrá filtrar por disponible ya que no son visibles en la bandeja
		List<EstadoInformesEnum> listEstadoInformes = new ArrayList<EstadoInformesEnum>();
		for (EstadoInformesEnum estado : EstadoInformesEnum.values()) {
			if (estado.compareTo(EstadoInformesEnum.DISPONIBLE) != 0) {
				listEstadoInformes.add(estado);
			}
		}

		model.addAttribute("TipoEstado", listEstadoInformes);

		List<TipoInformesEnum> listTipoInformes = new ArrayList<TipoInformesEnum>();
		if (UtilSeguridad.isDSS(request) || UtilSeguridad.isAdmin(request) || UtilSeguridad.isDirector(request)) {
			listTipoInformes = Arrays.asList(TipoInformesEnum.values());
		} else if (UtilSeguridad.isSSB(request)) {
			listTipoInformes.add(TipoInformesEnum.INFSOC);
			listTipoInformes.add(TipoInformesEnum.INFINT);
		} else if (UtilSeguridad.isPS(request)) {
			listTipoInformes.add(TipoInformesEnum.INFINT);
			listTipoInformes.add(TipoInformesEnum.INFSUM);
		}
		model.addAttribute("TipoInformes", listTipoInformes);

		model.addAttribute("nombreUsuarioConectado", UtilSeguridad.getAuditUser());

		HttpSession sesion = request.getSession();
		Long ayuntamientoSeleccionado = (Long) sesion.getAttribute(Constantes.VARCONTEXTO_AYUNTAMIENTO_SELECCIONADO);
		Ayuntamientos ayuntamiento = this.ayuntamientosService.find(new Ayuntamientos(ayuntamientoSeleccionado));

		model.addAttribute("ayuntamiento", ayuntamiento == null ? new Ayuntamientos() : ayuntamiento);

		Usuarios usuario = new Usuarios();
		usuario.setUsuXlnets80(UtilSeguridad.getUsuarioConectado().getUserName());
		List<Usuarios> listaUsuarios = usuariosService.findAllLike(usuario, null, false);
		if (!listaUsuarios.isEmpty()) {
			usuario = listaUsuarios.get(0);
		}

		model.addAttribute("usuario", usuario);

		model.addAttribute("isDSS", UtilSeguridad.isDSS(request));
		model.addAttribute("isAdmin", UtilSeguridad.isAdmin(request));
		model.addAttribute("isSSB", UtilSeguridad.isSSB(request));
		model.addAttribute("isPS", UtilSeguridad.isPS(request));
		model.addAttribute("isDirector", UtilSeguridad.isDirector(request));
//		if (Boolean.FALSE.equals(this.validarUsuarioAcceso(request))) {
//			return "accessDenied";
//		}

		model.addAttribute("title", UtilLiterales.getLiteralMessage(appMessageSource, "title.bandejaInformes"));

		return "informes";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterInformes  Informes Bean que contiene los parametros de filtrado
	 *                        a emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Informes> Dto que contiene el resultado del filtrado
	 *         realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Informes> filter(@RequestJsonBody(param = "filter") Informes filterInformes,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request) {
		InformesController.logger.info("[POST - filter] : Obtener Informess");
		Integer usuario = null;
//		if (UtilSeguridad.isDSS(request) || UtilSeguridad.isDirector(request)) {
//			usuario = 1;
//		} else if (UtilSeguridad.isPS(request)) {
//			usuario = 2;
//		} else if (UtilSeguridad.isSSB(request)) {
//			usuario = 3;
//		} else if (UtilSeguridad.isAdmin(request)) {
//			usuario = 4;
//		}

		if (UtilSeguridad.isDSS(request) || UtilSeguridad.isDirector(request)) {
			usuario = ActoresEnum.DSS.getId().intValue();
		} else if (UtilSeguridad.isPS(request)) {
			usuario = ActoresEnum.PS.getId().intValue();
		} else if (UtilSeguridad.isSSB(request)) {
			usuario = ActoresEnum.SSB.getId().intValue();
		} else if (UtilSeguridad.isAdmin(request)) {
			usuario = ActoresEnum.ADMIN.getId().intValue();
		}

		if (UtilSeguridad.isSSB(request)) {
			HttpSession sesion = request.getSession();
			Long idAyuntamiento = (long) sesion.getAttribute(Constantes.VARCONTEXTO_AYUNTAMIENTO_SELECCIONADO);
			filterInformes.setAyuntamiento(new Ayuntamientos(idAyuntamiento));
		}
		return this.informesService.filterPorUsuario(filterInformes, tableRequestDto, false, usuario);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterInformes  Informes Bean que contiene los parametros de filtrado
	 *                        a emplear.
	 * @param searchInformes  Informes Bean que contiene los parametros de busqueda
	 *                        a emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<Informes> Dto que contiene el resultado de la busqueda
	 *         realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<Informes>> search(@RequestJsonBody(param = "filter") Informes filterInformes,
			@RequestJsonBody(param = "search") Informes searchInformes,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		InformesController.logger.info("[POST - search] : Buscar Informess");
		return this.informesService.search(filterInformes, searchInformes, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterInformes  Informes Bean que contiene los parametros de filtrado
	 *                        a emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody TableRequestDto tableRequestDto) {
		InformesController.logger.info("[POST - removeMultiple] : Eliminar multiples Informess");
		this.informesService.removeMultiple(tableRequestDto);
		InformesController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los registros
	 * mediante visualizacion jerarquica.
	 * 
	 * @param filterInformes  Informes Bean que contiene los parametros de filtrado
	 *                        a emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Informes>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Informes>> jerarquia(
			@RequestJsonBody(param = "filter") Informes filterInformes,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		InformesController.logger.info("[POST - jerarquia] : Obtener Informess jerarquia");
		return this.informesService.jerarquia(filterInformes, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterInformes  Informes Bean que contiene los parametros de filtrado
	 *                        a emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Informes>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Informes>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Informes filterInformes,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		InformesController.logger.info("[POST - jerarquia] : Obtener Informess jerarquia - Hijos");
		return this.informesService.jerarquiaChildren(filterInformes, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */
	/**
	 * Devuelve los datos exportados de la tabla y los copia al Portapapeles.
	 *
	 * @param filterInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<Informes> getClipboardReport(
			@RequestJsonBody(param = "filter") Informes filterInformes,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		InformesController.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.informesService.getMultiple(filterInformes, tableRequestDto, false);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Informes
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateExcelReport(
			@RequestJsonBody(param = "filter", required = false) Informes filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		InformesController.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");

		this.informesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Informes
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generatePDFReport(@RequestJsonBody(param = "filter", required = false) Informes filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		InformesController.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");

		this.informesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Informes
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateODSReport(@RequestJsonBody(param = "filter", required = false) Informes filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		InformesController.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");

		this.informesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Informes
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateCSVReport(@RequestJsonBody(param = "filter", required = false) Informes filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		InformesController.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");

		this.informesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	@RequestMapping(value = "/ocultar/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody String ocultar(@PathVariable Long idInforme16) throws Throwable {
		InformesController.logger.info("[POST - filter] : ocultar BandejaInformes");
		this.informesService.ocultar(new Informes(idInforme16));
		return "ok";
	}

	@RequestMapping(value = "/mostrar/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody String mostrar(@PathVariable Long idInforme16) throws Throwable {
		InformesController.logger.info("[POST - filter] : ocultar BandejaInformes");
		this.informesService.mostrar(new Informes(idInforme16));
		return "ok";
	}

	@RequestMapping(value = "/solicitarInformeIntervenciones", method = RequestMethod.POST)
	public @ResponseBody String solicitarInformeIntervenciones(@RequestJsonBody Informes informe,
			HttpServletRequest request) throws Throwable {

		informe.setTipoInforme16(TipoInformesEnum.INFINT.getId());
		informe.setEstado16(EstadoInformesEnum.SOLICITADO.getId());
		informe.setOrigen16(com.ejie.ad74a.util.constantes.Constantes.OrigenInformeSocialEnum.SSB.getId());
		informe.setUsuAlta16(UtilSeguridad.getUsuarioConectado().getUserName());

		Usuarios usuario = new Usuarios();
		usuario.setUsuXlnets80(UtilSeguridad.getUsuarioConectado().getUserName());
		List<Usuarios> listaUsuarios = usuariosService.findAllLike(usuario, null, false);
		if (!listaUsuarios.isEmpty()) {
			usuario = listaUsuarios.get(0);
		}
		informe.setUsuario(usuario);

		HttpSession sesion = request.getSession();
		Long ayuntamientoSeleccionado = (Long) sesion.getAttribute(Constantes.VARCONTEXTO_AYUNTAMIENTO_SELECCIONADO);
		Ayuntamientos ayuntamiento = this.ayuntamientosService.find(new Ayuntamientos(ayuntamientoSeleccionado));
		informe.setAyuntamiento(ayuntamiento);

		informe = this.informesService.add(informe);

		Avisos aviso = new Avisos();
		aviso.setMaestroTiposAviso(new MaestroTiposAviso(TipoAvisoEnum.INFINT.getIdLongValue()));
		aviso.setMaestroSubtiposAviso(new MaestroSubtiposAviso(SubTipoAvisoEnum.SOLICDSS.getIdLongValue()));
		aviso.setMaestroActoresByDestino20(new MaestroActores(ActoresEnum.DSS.getId()));
		aviso.setMaestroActoresByOrigen20(new MaestroActores(ActoresEnum.SSB.getId()));
		aviso.setIdSolicitante20(informe.getSolicitantes().getIdSolicitante01());
		aviso.setObservaciones20(informe.getObservaciones16());
		aviso.setUrgencia20(informe.getUrgente16() != null && informe.getUrgente16() > 0);
		aviso.setUsuAlta20(com.ejie.ad74a.constantes.Constantes.COD_APLICACION);
		aviso.setIdInforme20(informe.getIdInforme16());
		this.avisosService.insertAvisos(aviso);

		return "ok";
	}

	@RequestMapping(value = "/generarDocumento/{idInfSocial02}", method = RequestMethod.GET)
	public void generarDocumento(@PathVariable String idInfSocial02, HttpServletRequest request,
			HttpServletResponse response) throws Throwable {
		InformesController.logger.info("[POST - filter] : ocultar BandejaInformes");

		// almacenamos el documento
//		DocumentosInforme docInforme = new DocumentosInforme();
//		docInforme.setUrlRuta17(rutaPifPdf);
//		docInforme.setIdTipoDoc17(TiposDocumentoRoleEnum.INFORME_SOCIAL.getId());
//		docInforme = this.documentosInformeService.add(docInforme);
//		Informes informe = new Informes();
//		informe.setIdInforme16(Long.valueOf(idInforme16));
//		informe.setDocumentosInforme(docInforme);
//		informe.setEstado16(EstadoInformesEnum.PENDIENTE_FIRMAR.getId());
//
//		this.informesService.updateDocInforme(informe);

		// Create JAXB Context
		JAXBContext jaxbContext = JAXBContext.newInstance(InformeSocialPDF.class);

		// Create Marshaller
		Marshaller jaxbMarshaller = jaxbContext.createMarshaller();

		// Required formatting??
		jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

		// Print XML String to Console
		StringWriter sw = new StringWriter();

		InformeSocialPDF inf = new InformeSocialPDF(
				this.informeSocialService.find(new InformeSocial(Long.valueOf(idInfSocial02))));

		Integer usuario = null;
		if (UtilSeguridad.isDSS(request) || UtilSeguridad.isDirector(request)) {
			usuario = ActoresEnum.DSS.getId().intValue();
		} else if (UtilSeguridad.isPS(request)) {
			usuario = ActoresEnum.PS.getId().intValue();
		} else if (UtilSeguridad.isSSB(request)) {
			usuario = ActoresEnum.SSB.getId().intValue();
		} else if (UtilSeguridad.isAdmin(request)) {
			usuario = ActoresEnum.ADMIN.getId().intValue();
		}
		List<Informes> result = informesService
				.findAllLikePorUsuario(new Informes(inf.getInformeSocial().getIdInforme02()), null, false, usuario);

		inf.setInformes(result.get(0));
		UnidadesBase unidadBase = this.unidadesBaseDao.find(new UnidadesBase(inf.getInformes().getIdUnidadBase16()));
		if (unidadBase != null) {
			inf.getInformes().setUnidadBase16(unidadBase.getDesc());
		}

		ConvivientesInfSoci conviviente = new ConvivientesInfSoci();
		conviviente.setIdInfSocial82(Long.valueOf(idInfSocial02));
		List<ConvivientesInfSoci> convivientes = this.convivientesInfSociService.findAllLike(conviviente, null, false);
		inf.getInformeSocial().setConvivientes(convivientes);
		// Write XML to StringWriter
		jaxbMarshaller.marshal(inf, sw);

		// Verify XML Content
		String xmlContent = sw.toString();

		String pathXSL = this.appConfiguration.getProperty("ruta.datos.plantillas") + "/"
				+ com.ejie.ad74a.util.constantes.Constantes.PlantillasDoc.INFORME_SOCIAL;
		String name = "InfSocial" + idInfSocial02 + "_" + System.currentTimeMillis() + ".pdf";

		String rutaTemp = this.documentosService.generarDocumentoFop(pathXSL, xmlContent, "", name);

		File file = new File(rutaTemp);

		InputStream in = new FileInputStream(file);

		UtilWeb.downloadFile(name, "application/download", 0, in, response, "");

		in.close();
		file.delete();
	}

	@RequestMapping(value = "/aportar/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody Informes aportar(@PathVariable Long idInforme16,
			@RequestParam(value = "documento", required = false) MultipartFile documento,
			@RequestParam(value = "id", required = false) String id) throws Throwable {
		return this.informesService.aportar(new Informes(idInforme16), documento);
	}

	@RequestMapping(value = "/eliminar/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody String eliminar(@PathVariable Long idInforme16) throws Throwable {
		this.informesService.eliminar(new Informes(idInforme16));
		return "ok";
	}

	@RequestMapping(value = "/aniadirContrato/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody String aniadirContrato(@PathVariable String idInforme16) throws Throwable {
		InformesController.logger.info("[POST - filter] : ocultar BandejaInformes");
		return "ok";
	}

	@RequestMapping(value = "/firmar/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody String firmar(@PathVariable String idInforme16) throws Throwable {
		InformesController.logger.info("[POST - filter] : ocultar BandejaInformes");
		return "ok";
	}

	@RequestMapping(value = "/enviarDSS/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody Informes enviarADss(@PathVariable Long idInforme16, HttpServletRequest request)
			throws Throwable {
		InformesController.logger.info("[POST - filter] : enviar a DSS BandejaInformes");
		return this.informesService.enviarDSS(new Informes(idInforme16), request);
	}

	@RequestMapping(value = "/detail/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody Informes getDetail(@PathVariable Long idInforme16) {
//		Informes informe = this.informesService.obtenerInforme(new Informes(idInforme16));
//		List<Informes> listaInformes = this.informesService.informesComplete(informe, null);
		List<Informes> listaInformes = this.informesService.informesComplete(new Informes(idInforme16), null);
		return !listaInformes.isEmpty() && listaInformes.size() == 1 ? listaInformes.get(0) : new Informes();
	}

	@RequestMapping(value = "/detailNoInfSoc/{idInforme16}", method = RequestMethod.POST)
	public @ResponseBody Informes getDetailNoInfSoc(@PathVariable Long idInforme16) {
		List<Informes> listaInformes = this.informesService.informesCompleteNoInfSoc(new Informes(idInforme16));
		return !listaInformes.isEmpty() && listaInformes.size() == 1 ? listaInformes.get(0) : new Informes();
	}

	@PostMapping(value = "/updateInformeSocial")
	public @ResponseBody String updateInformeSocial(@RequestBody Informes informe) {

		informe.setUsuModif16(UtilSeguridad.getUsuarioConectado().getUserName());
		informe.setfModif16(UtilidadesFecha.getFechaSistema());

		this.informesService.updateInformeSocial(informe);
		return "ok";
	}

	@RequestMapping(value = "/insertInformeSocial", method = RequestMethod.POST)
	public @ResponseBody Informes insertInformeSocial(@RequestBody Informes informe, HttpServletRequest request) {

		informe.setUsuAlta16(UtilSeguridad.getUsuarioConectado().getUserName());
		Usuarios usuario = new Usuarios();
		usuario.setUsuXlnets80(UtilSeguridad.getUsuarioConectado().getUserName());
		List<Usuarios> listaUsuarios = usuariosService.findAllLike(usuario, null, false);
		if (!listaUsuarios.isEmpty()) {
			usuario = listaUsuarios.get(0);
		}
		informe.setUsuario(usuario);

		if (informe.getInformeSocial() != null) {
			HttpSession sesion = request.getSession();
			List<ConvivientesInfSoci> convivientes = new ArrayList<ConvivientesInfSoci>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES) != null) {
				convivientes = (List<ConvivientesInfSoci>) sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES);
			}
			informe.getInformeSocial().setConvivientes(convivientes);
			Long ayuntamientoSeleccionado = (Long) sesion
					.getAttribute(Constantes.VARCONTEXTO_AYUNTAMIENTO_SELECCIONADO);
			Ayuntamientos ayuntamiento = this.ayuntamientosService.find(new Ayuntamientos(ayuntamientoSeleccionado));

			// informe.getInformeSocial().setAyuntamiento(ayuntamiento);
			informe.setAyuntamiento(ayuntamiento);
			informe.getInformeSocial().setUsuario(usuario);

		}
		return this.informesService.insertInformeSocial(informe);
	}

	private Boolean validarUsuarioAcceso(HttpServletRequest request) {
		Boolean isUsuarioAcceso = false;

		Boolean tieneAcceso;

		String[] perfilesAcceso = { UtilSeguridad.Props.PERFIL_SEGURIDAD_ADMINISTRADOR.getValue(),
				UtilSeguridad.Props.PERFIL_SEGURIDAD_DIRECTOR_DSS.getValue(),
				UtilSeguridad.Props.PERFIL_SEGURIDAD_TECNICO_DSS.getValue(),
				UtilSeguridad.Props.PERFIL_SEGURIDAD_SSB.getValue(),
				UtilSeguridad.Props.PERFIL_SEGURIDAD_PRESTADOR_SERVICIO.getValue(),
				// UtilSeguridad.Props.PERFIL_SEGURIDAD_TECNICO_LAKUA.getValue(),
				UtilSeguridad.Props.PERFIL_SEGURIDAD_ADMINISTRATIVO_LAKUA.getValue() };
		tieneAcceso = UtilSeguridad.tienePerfilSeguridad(request, perfilesAcceso);

		// Boolean esAdmin = UtilSeguridad.isAdmin();

		if (tieneAcceso) {
			isUsuarioAcceso = true;
		}

		return isUsuarioAcceso;

	}

	private Boolean modoConsulta(HttpServletRequest request) {
		Boolean modoConsulta = false;

		Boolean tieneAcceso;

		String[] perfilesAcceso = { UtilSeguridad.Props.PERFIL_SEGURIDAD_TECNICO_DSS.getValue() };
		tieneAcceso = UtilSeguridad.tienePerfilSeguridad(request, perfilesAcceso);

		if (tieneAcceso) {
			modoConsulta = true;
		}

		return modoConsulta;

	}

	@RequestMapping(value = "/obtenerDatosBeneficiario/{dni}", method = RequestMethod.POST)
	public @ResponseBody Solicitantes obtenerDatosBeneficiario(@PathVariable String dni,
			@RequestJsonBody(param = "beneficiario", required = false) int beneficiario, HttpServletRequest request) {
		Solicitantes solicitantes = new Solicitantes();
		solicitantes.setIdentificador01(dni);
		solicitantes.setBeneficiario01(beneficiario == 1 ? Constantes.UNO : null);
		TableRequestDto tableRequestDto = new TableRequestDto();
		tableRequestDto.setSord("DESC");
		tableRequestDto.setSidx("BENEFICIARIO01"); // Nos interesan primero los que son beneficiarios
		List<Solicitantes> listaSolicitantes = this.solicitantesService.findAllLike(solicitantes, null, false);

		HttpSession sesion = request.getSession();
		Long ayuntamientoSeleccionado = (Long) sesion.getAttribute(Constantes.VARCONTEXTO_AYUNTAMIENTO_SELECCIONADO);
		Ayuntamientos ayuntamiento = this.ayuntamientosService.find(new Ayuntamientos(ayuntamientoSeleccionado));

		// TODO: qué hacer si el beneficiario existe con otro DNI en otro municipio?
		if (!listaSolicitantes.isEmpty() && listaSolicitantes.size() > 0) {
			if (ayuntamiento.getMunicipio().getCodMunicipio()
					.equalsIgnoreCase(listaSolicitantes.get(0).getDirecciones().getMunicipioNORA().getCodMunicipio())) {
				return listaSolicitantes.get(0);
			} else {
				ManagerErrors.manageError(
						UtilLiterales.getLiteralMessage(appMessageSource, "error.beneficiarioNoMunicipio"));
			}
		}

		return new Solicitantes();

	}

	@RequestMapping(value = "/obtenerDatosTrSocial/{dni}", method = RequestMethod.POST)
	public @ResponseBody MaestroTrSociales obtenerDatosTrSocial(@PathVariable String dni) {
		MaestroTrSociales maestroTrSociales = new MaestroTrSociales();
		maestroTrSociales.setIdentificador39(dni);
		List<MaestroTrSociales> listaTrabajadoresSociales = this.maestroTrSocialesService.findAllLike(maestroTrSociales,
				null, false);
		return !listaTrabajadoresSociales.isEmpty() && listaTrabajadoresSociales.size() == 1
				? listaTrabajadoresSociales.get(0)
				: new MaestroTrSociales();

	}

	@RequestMapping(value = "/obtenerIdExpediente/{numExpediente}", method = RequestMethod.POST)
	public @ResponseBody Expedientes obtenerIdExpediente(@PathVariable String numExpediente) {
		Expedientes expediente = new Expedientes();
		expediente.setNumExpediente00(numExpediente);

		if (numExpediente.contains(ProcedimientosEnum.BAJA.getSufixProcedure())
				|| numExpediente.contains(ProcedimientosEnum.INFORME.getSufixProcedure())
				|| numExpediente.contains(ProcedimientosEnum.REVISION_PRECIO.getSufixProcedure())) {
			return new Expedientes();
		} else {
			List<Expedientes> listaExpedientes = this.expedientesService.findAllLike(expediente, null, false);
			return !listaExpedientes.isEmpty() && listaExpedientes.size() == 1 ? listaExpedientes.get(0)
					: new Expedientes();
		}

	}

	@RequestMapping(value = "/nuevoSolicitante", method = RequestMethod.POST)
	public @ResponseBody Solicitantes nuevoSolicitante(@RequestBody Solicitantes solicitatne) {

		return this.solicitantesService.add(solicitatne);

	}

	/**
	 * Método de presentación del RUP_TABLE para la búsqueda de expedientes
	 * 
	 * @param model Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/buscarExpediente", method = RequestMethod.GET)
	public String buscarExpediente(Model model) {
		InformesController.logger.info("[GET - View] : buscarExpediente");
		model.addAttribute("expediente", new Expedientes());
//		model.addAttribute("Procedimientos", ProcedimientosEnum.values());
		List<ProcedimientosEnum> procedimientos = new ArrayList<ProcedimientosEnum>();
		procedimientos.add(ProcedimientosEnum.ALTA);
		procedimientos.add(ProcedimientosEnum.MODIFICACION);
		model.addAttribute("Procedimientos", procedimientos);

		return "informesbuscarexpediente";
	}

	/***
	 * Hacer la búsuqeda de expedientes
	 * 
	 * @param filterExpedientes
	 * @param tableRequestDto
	 * @return
	 */
	@RequestMapping(value = "/expedientes/{idSolicitante01}/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Expedientes> filterExpedientes(@PathVariable Long idSolicitante01,
			@RequestJsonBody(param = "filter") Expedientes filterExpedientes,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		InformesController.logger.info("[POST - filter] : Obtener Expedientes");
		filterExpedientes.setSolicitantes(new Solicitantes(idSolicitante01));
		List<String> procedimientosFilter = new ArrayList<String>();
		procedimientosFilter.add(ProcedimientosEnum.ALTA.getId());
		procedimientosFilter.add(ProcedimientosEnum.MODIFICACION.getId());
		filterExpedientes.setProcedimientosFilter(procedimientosFilter);
		filterExpedientes.setNoCerrado(true);
		return this.expedientesService.findPapel0(filterExpedientes, tableRequestDto, false);
	}

	@RequestMapping(value = "/downloadInforme/{oid}", method = RequestMethod.GET)
	public void downloadDocument(@PathVariable String oid, @RequestParam(required = true) String nombreDoc,
			HttpServletResponse response) throws IOException, Ad74aWebserviceException {

		String rutaPif = "";
		if (!Utilidades.esBlancoNulo(oid)) {
			try {

				rutaPif = this.appConfiguration.getProperty("webservice.dokusi.pif.dir");
				W43DfDocument docPid = pidWS.get(oid, rutaPif);
				rutaPif = docPid.getContent().getPath();
				InformesController.logger.info(
						"InformesController.downloadDocument - Ad74aPIFws.getInstance().downloadDocument path = {}",
						rutaPif);
				InputStream inputStream = Ad74aPIFws.getInstance().downloadDocument(rutaPif);
				UtilWeb.downloadFile(nombreDoc, docPid.getContent().getFormat().getMimeType(), 0, inputStream, response,
						"");
			} catch (Exception e) {
				ManagerErrors.manageException(e, "Error al descargar el documento");
			} finally {
				Ad74aPIFws.getInstance().deleteDocument(rutaPif);
			}
		}

	}

	/**
	 * Borrar el documento y cambia el estado a PENDIENTE DE APORTAR
	 * 
	 * @param informe
	 * @param request
	 * @return Informes
	 * @throws Throwable
	 */
	@RequestMapping(value = "/borrarDocumento", method = RequestMethod.POST)
	public @ResponseBody String borrarDocumento(@RequestJsonBody Informes informe) throws Throwable {
		InformesController.logger.info("[POST - filter] : borrar documento");
		this.informesService.borrarDocumento(informe);
		return "ok";
	}

	@RequestMapping(value = "/informeSocialSinMatchByNIF", method = RequestMethod.PUT)
	protected @ResponseBody Informes getInformeSocialSinMatchByNIF(@RequestJsonBody(param = "nif") String nif) {
		return this.informesService.getInformeSocialSinMatchByNIF(nif, true);
	}

}
